﻿using System;

using Android.App;
using Android.Content;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;
using Android.Accounts;

namespace SyncAdapterExample
{
    [Activity(Label = "SyncAdapterExample", MainLauncher = true)]
    public class MainActivity : Activity
    {
        public static string AUTHORITY = "com.xamarin.example.provider";
            
        public static string ACCOUNT_TYPE = "example.com";

        public static string ACCOUNT = "dummyaccount";

        Account _account;

        protected override void OnCreate(Bundle bundle)
        {
            base.OnCreate(bundle);

            // Set our view from the "main" layout resource
            SetContentView(Resource.Layout.Main);
                    
            _account = CreateSyncAccount(this);

            var settingsBundle = new Bundle();
            settingsBundle.PutBoolean(ContentResolver.SyncExtrasManual, true);
            settingsBundle.PutBoolean(ContentResolver.SyncExtrasExpedited, true);

            var button = FindViewById<Button>(Resource.Id.myButton);

            button.Click += (object sender, EventArgs e) => {
                ContentResolver.RequestSync(_account, AUTHORITY, settingsBundle);
            };
        }

        public Account CreateSyncAccount(Context context)
        {
            Account newAccount = new Account(ACCOUNT, ACCOUNT_TYPE);

            AccountManager accountManager = (AccountManager)context.GetSystemService(Context.AccountService);

            if(accountManager.AddAccountExplicitly(newAccount, null, null))
            {

            }
            else
            {

            }

            return newAccount;
        }
    }
}


