﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;

namespace SyncAdapterExample
{
    [Service(Name = "com.xamarin.example.SyncService", Exported = true, Process = ":sync")]
    [IntentFilter(new[] { "android.content.SyncAdapter" })]
    [MetaData("android.content.SyncAdapter", Resource = "@xml/syncadapter")]
    public class SyncService : Service
    {
        static SyncAdapter _syncAdapter = null;
        static object _syncAdapterLock = new object();

        public override void OnCreate()
        {
            base.OnCreate();

            lock(_syncAdapterLock)
            {
                if(_syncAdapter == null)
                    _syncAdapter = new SyncAdapter(ApplicationContext, true);
            }
        }

        public override IBinder OnBind(Intent intent)
        {
            return _syncAdapter.SyncAdapterBinder;
        }
    }
}

